{- |

mtlstats
Copyright (C) Rhéal Lamothe
<rheal.lamothe@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

-}

module Mtlstats.Handlers (ynHandler) where

import Brick.Types (BrickEvent (VtyEvent))
import Data.Char (toUpper)
import Graphics.Vty.Input.Events (Event (EvKey), Key (KChar))

-- | Handler for a yes/no prompt
ynHandler :: BrickEvent () () -> Maybe Bool
ynHandler (VtyEvent (EvKey (KChar c) [])) = case toUpper c of
  'Y' -> Just True
  'N' -> Just False
  _   -> Nothing
ynHandler _ = Nothing
